'FFSubmenu=Skalieren
'FFName=PortraitToLandscape

'(c) Harald Maeckler, Dsseldorf 2017
' ***********************************************************************
' PortraitToLandscape.vbs (Skript fr FixFoto)
' Bild im Hochformat vergrern auf Querformat
' ***********************************************************************
'
' Version 1.07 vom 22.10.2017	- Erhalt der Exif- und IPTC-Daten, sofern vorhanden
'									bei 2 Bilder werden die Daten des Bildes auf der Arbeitsflche bernommen
' Version 1.06 vom 07.10.2017	- Zwei Bilder knnen eingefgt werden
'								- Skalierung der Randbreite korrigiert
'								- nachgebessert am 10.10.2017
'								- Info zum Einfgen von 2 Bildern hinzu am 12.10.2017
' Version 1.05 vom 01.10.2017	- Unschrfe mit Option'verstrkt'
' Version 1.04 vom 21.09.2017	- eine Sollgre ist standardmig vorgegeben,
'									weitere Sollgren knnen vom Anwender abgespeichert
'									und bei Bedarf auch wieder gelscht werden
' Version 1.03 vom 18.09.2017	- Wirkung von Unschrfe nochmals verstrkt
'								- min/max-Button fr Helligkeit und Unschrfe
'								- neutral-Button fr Helligkeit
'								- Vertikallage wird bei 'Vorschau' nur auf 0 gesetzt
'									wenn vorher die Sollgre gendert wurde
' Version 1.02 vom 06.09.2017	- Wirkung von Helligkeit und Unschrfe verdoppelt
'								- Bildrand einstellbar bezglich Breite und Farbe
' Version 1.01 vom 04.09.2017	- Bild horizontal verschiebbar auf Links, Mitte, Rechts
' Version 1.00 vom 31.08.2017	- Betaversion
' ***********************************************************************

'**Start Encode**

Option Explicit

'Updatekonstanten und Variable
const SkriptVersion = "1.07"
const SkriptURL = "http://www.ffsf.de/resources/portraittolandscape.361/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

'allgemeine Konstanten und Variable
const ForReading = 1, ForWriting = 2
Dim Abbruch,Antwort,n,Anzeige,element

'Spezifische Konstanten und Variable
Dim TMPbildO,TMPbildV,IBreite,IHoehe,SB_Alt,SH_Alt
Dim SG_Auswahl,SGA_Liste,SGA_Array,SG_Wert,SGW_Liste,SGW_Array,SGWe_Array,SBreite,SHoehe
Dim SG_Name,SG_Breite,SG_Hoehe,SGL_Auswahl,SGL_Wert,SGL_flag : SGL_flag = false
Dim FaktorL,Lage_Wert,FaktorU,US_Wert,flag_USturbo,FaktorH,HK_Wert	
Dim HK_Neutral : HK_Neutral = false
Dim Hz_Lage,Rd_Wert,Rd_Farbe,RD_FarbArray
Dim B_Name2,IBreite2,IHoehe2

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim SkriptKill,TempFile	 : SkriptKill = false
Dim SkriptName
const Skript = "PortraitToLandscape"					'Skriptname
const RegSchluessel = "FF_PortraitToLandscape"			'Registryschlssel

' ***********************************************************************
call main
Set WshShell = Nothing
Set objFS = Nothing
' ***********************************************************************
Sub main

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err <> 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

TMPbildO = FF_GetScriptPath & "\MeckiScript\PortraitToLandscape\PortraitTmpO.jpg"
TMPbildV = FF_GetScriptPath & "\MeckiScript\PortraitToLandscape\PortraitTmpV.jpg"

if objFS.FileExists(TMPbildO) then
	objFS.DeleteFile TMPbildO,true
end if
if objFS.FileExists(TMPbildV) then
	objFS.DeleteFile TMPbildV,true
end if

'** Start Dialog PortraitToLandscape **
FF_AddDialog "PortraitToLandscape",325,312
FF_AddControl "PortraitToLandscape","Sollgre","GROUP",5,5,76,66
FF_AddControl "PortraitToLandscape","Hintergrund","GROUP",88,5,174,66
FF_AddControl "PortraitToLandscape","Vertikallage","GROUP",92,20,50,48
FF_AddControl "PortraitToLandscape","Unschrfe","GROUP",149,9,50,59
FF_AddControl "PortraitToLandscape","Helligkeit","GROUP",206,9,50,59
FF_AddControl "PortraitToLandscape","Bild","GROUP",268,5,52,66
FF_AddControl "PortraitToLandscape","+","STATIC",95,28,10,10
FF_SetControlStyle "PortraitToLandscape","+",1
FF_AddControl "PortraitToLandscape","HG_Lage","VSPIN",96,39,11,16
FF_AddControl "PortraitToLandscape","-","STATIC",95,56,10,10
FF_SetControlStyle "PortraitToLandscape","-",1
FF_AddControl "PortraitToLandscape","Lage_Wert","SLEDIT",108,42,16,10
FF_SetControlStyle "PortraitToLandscape","Lage_Wert",2049
FF_AddControl "PortraitToLandscape","++","STATIC",126,28,10,10
FF_SetControlStyle "PortraitToLandscape","++",1
FF_AddControl "PortraitToLandscape","HG_Lage+","VSPIN",127,39,11,16
FF_AddControl "PortraitToLandscape","--","STATIC",126,56,10,10
FF_SetControlStyle "PortraitToLandscape","--",1
FF_AddControl "PortraitToLandscape","+|","STATIC",152,28,10,10
FF_SetControlStyle "PortraitToLandscape","+|",1
FF_AddControl "PortraitToLandscape","US_Faktor","VSPIN",153,39,11,16
FF_AddControl "PortraitToLandscape","-|","STATIC",152,56,10,10
FF_SetControlStyle "PortraitToLandscape","-|",1
FF_AddControl "PortraitToLandscape","US_Wert","SLEDIT",165,42,16,10
FF_SetControlStyle "PortraitToLandscape","US_Wert",2049
FF_AddControl "PortraitToLandscape","++|","STATIC",184,28,10,10
FF_SetControlStyle "PortraitToLandscape","++|",1
FF_AddControl "PortraitToLandscape","US_Faktor+","VSPIN",184,39,11,16
FF_AddControl "PortraitToLandscape","--|","STATIC",184,56,10,10
FF_SetControlStyle "PortraitToLandscape","--|",1
FF_AddControl "PortraitToLandscape","neutral","BUTTON",217,17,29,10
FF_AddControl "PortraitToLandscape","+||","STATIC",210,28,10,10
FF_SetControlStyle "PortraitToLandscape","+||",1
FF_AddControl "PortraitToLandscape","HK_Faktor","VSPIN",211,39,11,16
FF_AddControl "PortraitToLandscape","-||","STATIC",210,56,10,10
FF_SetControlStyle "PortraitToLandscape","-||",1
FF_AddControl "PortraitToLandscape","HK_Wert","SLEDIT",223,42,16,10
FF_SetControlStyle "PortraitToLandscape","HK_Wert",2049
FF_AddControl "PortraitToLandscape","++||","STATIC",241,28,10,10
FF_SetControlStyle "PortraitToLandscape","++||",1
FF_AddControl "PortraitToLandscape","HK_Faktor+","VSPIN",242,39,11,16
FF_AddControl "PortraitToLandscape","--||","STATIC",241,56,10,10
FF_SetControlStyle "PortraitToLandscape","--||",1
FF_AddControl "PortraitToLandscape","Horizontallage","STATIC",275,14,38,10
FF_SetControlStyle "PortraitToLandscape","Horizontallage",1
FF_AddControl "PortraitToLandscape","Hz_Lage","COMBO",278,25,33,10
FF_AddControl "PortraitToLandscape","Rand","STATIC",272,42,16,10
FF_AddControl "PortraitToLandscape","Rd_Wert","COMBO",288,42,20,10
FF_AddControl "PortraitToLandscape","px||","STATIC",309,42,8,10
FF_AddControl "PortraitToLandscape","Farbe","STATIC",272,55,16,10
FF_AddControl "PortraitToLandscape","Rd_Farbe","COLOR",288,55,28,11
FF_AddControl "PortraitToLandscape","V_Image","IMAGE",5,79,315,210
FF_AddControl "PortraitToLandscape","?","BUTTON",29,295,11,11
FF_AddControl "PortraitToLandscape","|","STATIC",42,295,22,11
FF_SetControlStyle "PortraitToLandscape","|",1
FF_AddControl "PortraitToLandscape","Update","BUTTON",66,295,33,11
FF_AddControl "PortraitToLandscape","Abbrechen","BUTTON",216,295,33,11
FF_AddControl "PortraitToLandscape","OK","BUTTON",259,295,33,11
FF_AddControl "PortraitToLandscape","&delete","BUTTON",0,0,1,1
FF_AddControl "PortraitToLandscape","max","BUTTON",164,29,18,10
FF_AddControl "PortraitToLandscape","min","BUTTON",164,55,18,10
FF_AddControl "PortraitToLandscape","max|","BUTTON",222,29,18,10
FF_AddControl "PortraitToLandscape","min|","BUTTON",222,55,18,10
FF_AddControl "PortraitToLandscape","SG_Auswahl","COMBO",8,18,70,10
FF_AddControl "PortraitToLandscape","||","STATIC",8,33,70,10
FF_SetControlStyle "PortraitToLandscape","||",1
FF_AddControl "PortraitToLandscape","Lschen","BUTTON",9,51,33,11
FF_AddControl "PortraitToLandscape","Neu","BUTTON",44,51,33,11
FF_AddControl "PortraitToLandscape","flag_USturbo","BOOL",156,18,8,8
FF_SetControlStyle "PortraitToLandscape","flag_USturbo",16384
FF_AddControl "PortraitToLandscape","verstrkt","STATIC",168,17,24,10
FF_AddControl "PortraitToLandscape","2 Bilder ?","BUTTON",109,295,33,11
'** End Dialog PortraitToLandscape **

FF_SetControl "PortraitToLandscape","Lage_Wert",0

if FF_GetImageCount > 0 then FF_SetControl "PortraitToLandscape","Hz_Lage","2 Bilder"
FF_SetControl "PortraitToLandscape","Hz_Lage","Links"
FF_SetControl "PortraitToLandscape","Hz_Lage","Mitte"
FF_SetControl "PortraitToLandscape","Hz_Lage","Rechts"

for n = 0 to 20 step 2
	FF_SetControl "PortraitToLandscape","Rd_Wert",n
next

call RegistryLesen

if FF_GetControl("PortraitToLandscape","SG_Auswahl") = SGA_Array(0) then
	FF_EnableControl "PortraitToLandscape","Lschen",false
end if

'Vorschau
if FF_GetImageWidth = 0 then
	msgbox "Bitte Bild" & vbNewLine & "auf die Arbeitsflche laden!",vbInformation,"Abbruch"
	exit sub
end if
FF_SaveImage TMPbildO,0

FF_SetControl "PortraitToLandscape","Lage_Wert",0

call Werte_auslesen
SB_Alt = SBreite : SH_Alt = SHoehe
if not Abbruch then call Kontrolle
if not Abbruch then call Start else exit sub

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "PortraitToLandscape","Lschen", "" &_
						 "Sollgre lschen"
	FF_SetControlTooltip "PortraitToLandscape","Neu", "" &_
						 "Neue Sollgre definieren"
	FF_SetControlTooltip "PortraitToLandscape","?", "" &_
						 "Anzeige der Kurzbeschreibung"
	FF_SetControlTooltip "PortraitToLandscape","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "PortraitToLandscape","2 Bilder ?", "" &_
						 "Info zum Einfgen von 2 Bildern"
	FF_SetControlTooltip "PortraitToLandscape","Abbrechen", "" &_
						 "Skript beenden"
	FF_SetControlTooltip "PortraitToLandscape","OK", "" &_
						 "bertragung auf die Arbeitsflche" & vbNewLine &_
						 "und Beenden des Skripts"
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 2500
FF_SetDialogTimer "PortraitToLandscape", 100
FF_ActivateControl "PortraitToLandscape","&delete"

do
	Abbruch = false
	Select Case FF_ShowDialog ("PortraitToLandscape")
	Case "TIMER"
		FF_SetDialogTimer "PortraitToLandscape", 0
		FF_SetControl "PortraitToLandscape" ,"|", "V " & Skriptversion
		FF_SetControl "PortraitToLandscape" ,"||","B x H = " & SG_Wert & " px"
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "SG_Auswahl"
		SG_Auswahl = FF_GetControl("PortraitToLandscape","SG_Auswahl")
		if SG_Auswahl = SGA_Array(0) then
			FF_EnableControl "PortraitToLandscape","Lschen",false
		else
			FF_EnableControl "PortraitToLandscape","Lschen",true
		end if
		if SGL_flag then call Def_Loeschen
		SGA_Array = split(SGA_Liste,"|")
		SGW_Array = split(SGW_Liste,"|")
		for n = 0 to ubound(SGA_Array)
			if SGA_Array(n) = SG_Auswahl then
				SG_Wert = SGW_Array(n)
				FF_SetControl "PortraitToLandscape" ,"||","B x H = " & SG_Wert & " px"
				exit for
			end if
		next
		SGWe_Array = split(SG_Wert," x ")
		SBreite = SGWe_Array(0) *1 : SHoehe = SGWe_Array(1) *1

		if objFS.FileExists(TMPbildO) then
			FF_LoadImage TMPbildO
		else
			FF_SaveImage TMPbildO,0
		end if
		call Werte_auslesen
		if SB_Alt <> SBreite or SH_Alt <> SHoehe then
			FF_SetControl "PortraitToLandscape","Lage_Wert",0
			Lage_Wert = 0
		end if
		SB_Alt = SBreite : SH_Alt = SHoehe
		if not Abbruch then call Kontrolle
		if not Abbruch then call Start
	Case "Lschen"
		if SGA_Array(0) = SG_Auswahl then
			msgbox "Die Sollgre '" & SG_Auswahl & "' gehrt" & vbNewLine &_
					"zum Skriptstandard. Sie kann nicht gelscht werden.",vbInformation,"Hinweis"
		else
			msgbox "Die Sollgre '" & SG_Auswahl & "' wird beim" & vbNewLine &_
					"nchsten Wechsel der Sollgre gelscht.",vbInformation,"Hinweis"
			SGL_Auswahl = SG_Auswahl : SGL_Wert = SG_Wert : SGL_flag = true
		end if
	Case "Neu"
		call Definition_Soll
	Case "HG_Lage"
		FaktorL = FF_GetControl("PortraitToLandscape","HG_Lage") * 5
		call Start
	Case "HG_Lage+"
		FaktorL = FF_GetControl("PortraitToLandscape","HG_Lage+") * 40
		call Start
	Case "max"
		FaktorU = 250
		call Start
	Case "flag_USturbo"
		flag_USturbo = FF_GetControl("PortraitToLandscape","flag_USturbo")
		call Start
	Case "US_Faktor"
		FaktorU = FF_GetControl("PortraitToLandscape","US_Faktor") * 10
		call Start
	Case "US_Faktor+"
		FaktorU = FF_GetControl("PortraitToLandscape","US_Faktor+") * 40
		call Start
	Case "min"
		FaktorU = -250
		call Start
	Case "neutral"
		HK_Neutral = true
		call Start
	Case "max|"
		FaktorH = 500
		call Start
	Case "HK_Faktor"
		FaktorH = FF_GetControl("PortraitToLandscape","HK_Faktor") * 10
		call Start
	Case "HK_Faktor+"
		FaktorH = FF_GetControl("PortraitToLandscape","HK_Faktor+") * 40
		call Start
	Case "min|"
		FaktorH = -500
		call Start
	Case "Hz_Lage"
		call Werte_Auslesen
		if not Abbruch then call Kontrolle
		if not Abbruch then call Start
	Case "Rd_Wert"
		Rd_Wert = FF_GetControl("PortraitToLandscape","Rd_Wert")
		call Start
	Case "Rd_Farbe"
		Rd_Farbe = FF_GetControl("PortraitToLandscape","Rd_Farbe")
		RD_FarbArray = split(Rd_Farbe," ")
		call Start
	Case "?"
		Anzeige = chr(34) & FF_GetScriptPath & "\MeckiScript\PortraitToLandscape\PortraitToLandscape.pdf" & chr(34)
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?).",vbExclamation,"Hinweis"
			err.clear
		end if
		on error GoTo 0
	Case "Update"
		if InternetConnection then
			SkriptEnde = false
			call Update
			if SkriptEnde then exit do
		end if
	Case "2 Bilder ?"
		WshShell.Popup 	"Es knnen auch zwei Bilder eingefgt werden." & vbNewLine & vbNewLine &_
						"Damit unter 'Bild / Horizontallage' die Option" & vbNewLine &_
						"'2 Bilder' zur Verfgung steht ist Voraussetzung," & vbNewLine &_
						"dass vor dem Start des Skripts ein Bild auf die" & vbNewLine &_
						"Arbeitsflche geladen und ein zweites Bild im" & vbNewLine &_
						"aktuellem Computerverzeichnis markiert wurde." & vbNewLine & VbNewLine &_
						"Nheres ist der Kurzbeschreibung (?) zu entnehmen." ,,"Hinweis",vbInformation
	Case "Abbrechen","CANCEL"
		SBreite = SBreite *1 : SHoehe = SHoehe *1
		if SBreite < SHoehe then
			FF_SetControl "PortraitToLandscape","SBreite",SHoehe
			FF_SetControl "PortraitToLandscape","SHoehe",SBreite
		end if
		exit do
	Case "OK"
		call Werte_auslesen
		if SBreite < SHoehe then
			msgbox "Die Sollgre muss ein querformatiges Bild ergeben!",vbInformation,"Abbruch"
		else
			call Start
			FF_Reload
			exit do
		end if
	End Select
loop

call RegistrySchreiben

if objFS.FileExists(TMPbildO) then
	objFS.DeleteFile TMPbildO,true
end if
if objFS.FileExists(TMPbildV) then
	objFS.DeleteFile TMPbildV,true
end if

FF_CloseDialog ("PortraitToLandscape")

if SkriptKill then			'ggf. Skript komplett entfernen
	call KillSkript
end if

end sub
'------------------------------------------------------------------------
Sub Start

call Bearbeitung (TMPbildO)
if not Abbruch then
	FF_SaveImage TMPbildV,0
	FF_SetControl "PortraitToLandscape","V_Image",TMPbildV
else
	FF_SetControl "PortraitToLandscape","V_Image",FF_GetScriptPath & "\MeckiScript\PortraitToLandscape\Fehlermeldung.png"
end if

end sub
'------------------------------------------------------------------------
Sub Bearbeitung (Foto)
Dim HHoehe,KBreite,VY,HX,L_left,L_right,Abstand,Rd_Wert1,Rd_Wert2

on error resume next

	FF_LoadImage Foto
	
	'Hintergrund erstellen
	FF_HQScale SBreite,IHoehe / IBreite * SBreite,false
	HHoehe = FF_GetImageHeight *1
	
	VY = int((HHoehe / 2 - SHoehe / 2) + Lage_Wert)
	if (VY + FaktorL) >= 0 and (VY + FaktorL) <= (HHoehe - SHoehe) then
		Lage_Wert = Lage_Wert + FaktorL
		FF_SetControl "PortraitToLandscape","Lage_Wert",Lage_Wert
		VY = VY + FaktorL
	end if
	
	FF_Crop 0,VY,SBreite,SHoehe
	
	'Unschrfe einstellen
	if (US_Wert + FaktorU) > 0 and (US_Wert + FaktorU) <= 250 then
		US_Wert = US_Wert + FaktorU
	else
		if FaktorU <= 0 then US_Wert = 0 else US_Wert = 250
	end if
	FF_SetControl "PortraitToLandscape","US_Wert",US_Wert
	if flag_USturbo = 1 and US_Wert > 0 then
		FF_HQScale 200,200,true
		FF_HamiltonSharp US_Wert,64
		FF_HQScale SBreite,SHoehe,false
		FF_Blur 32
	elseif US_Wert > 0 then
		FF_HamiltonSharp US_Wert,64
	end if

	'Helligkeit einstellen
	if HK_Neutral then
		HK_Neutral = false
		HK_Wert = 0
	elseif abs(HK_Wert + FaktorH) <= 250 then
		HK_Wert = HK_Wert + FaktorH
	else
		if FaktorH < 0 then HK_Wert = -250 else HK_Wert = 250
	end if
	FF_SetControl "PortraitToLandscape","HK_Wert",HK_Wert
	FF_BrightUpDown(HK_Wert) : FF_BrightUpDown(HK_Wert)
	
	'Bild pushen
	FaktorL = 0 : FaktorU = 0 : FaktorH = 0
	FF_PushImage
	
	'Originalbild laden und ggf. mit Rand versehen
	FF_LoadImage Foto
	IHoehe = FF_GetImageHeight
	Rd_Wert1 = Rd_Wert * IHoehe / SHoehe
	select case Hz_Lage
		case "Links"
			L_left = 0 : L_right = Rd_Wert1
		case "Mitte","2 Bilder"
			L_left = Rd_Wert1 : L_right = Rd_Wert1
		case "Rechts"
			L_left = Rd_Wert1 : L_right = 0	
	end select
	
	FF_ExtendCanvas L_left,L_right,0,0,RD_FarbArray(0),RD_FarbArray(1),RD_FarbArray(2)
	IBreite = FF_GetImageWidth
	IHoehe = FF_GetImageHeight
	
	'Originalbild auf den Hintergrund kopieren
	KBreite = IBreite / IHoehe * SHoehe
	select case Hz_Lage
		case "2 Bilder"
			Rd_Wert2 = Rd_Wert * IHoehe2 / SHoehe
			if KBreite + (IBreite2 + 2* Rd_Wert2) / (IHoehe2 + 2* Rd_Wert2) * SHoehe < SBreite then
				Abstand = (SBreite - (KBreite + (IBreite2 + 2* Rd_Wert2) / (IHoehe2 + 2* Rd_Wert2) * SHoehe)) \ 3
				HX = Abstand
			else
				Abstand = 0
				HX = 0
			end if
		case "Links","2 Bilder"
			HX = 0
		case "Mitte"
			HX = SBreite / 2 - KBreite / 2
		case "Rechts"
			HX = SBreite - KBreite
	end select
	FF_MixImage HX,0,KBreite,SHoehe,255
	
	'ggf. zweites Bild auf den Hintergrund kopieren
	if Hz_Lage = "2 Bilder" then
		FF_LoadImage(B_Name2)
		FF_ExtendCanvas Rd_Wert2,Rd_Wert2,0,0,RD_FarbArray(0),RD_FarbArray(1),RD_FarbArray(2)
		IBreite = FF_GetImageWidth
		IHoehe = FF_GetImageHeight
		KBreite = IBreite / IHoehe * SHoehe
		HX = SBreite - KBreite - Abstand
		FF_MixImage HX,0,KBreite,SHoehe,255
	end if
	
	'Gesamtbild nach oben holen / ggf. Fehler melden
	FF_PopImage

if err <> 0 then
	msgbox "Es liegt ein unbekannter Fehler vor!" & vbNewLine & "Bitte das Ausgangsbild kontrollieren.",vbExclamation,"Fehler"
	Abbruch = true
end if
on error goto 0

End Sub
'------------------------------------------------------------------------
Sub Definition_Soll

'** Start Dialog Sollgre **
FF_AddDialog "Sollgre",140,54
FF_AddControl "Sollgre","Bezeichnung","STATIC",15,5,36,10
FF_AddControl "Sollgre","SG_Name","SLEDIT",53,5,60,10
FF_SetControlStyle "Sollgre","SG_Name",1
FF_AddControl "Sollgre","Breite [px]","STATIC",5,20,32,10
FF_AddControl "Sollgre","SG_Breite","SLEDIT",38,20,28,10
FF_SetControlStyle "Sollgre","SG_Breite",8193
FF_AddControl "Sollgre","Hhe [px]","STATIC",76,20,32,10
FF_AddControl "Sollgre","SG_Hoehe","SLEDIT",106,20,28,10
FF_SetControlStyle "Sollgre","SG_Hoehe",8193
FF_AddControl "Sollgre","Abbrechen","BUTTON",38,38,33,11
FF_AddControl "Sollgre","Speichern","BUTTON",82,38,33,11
'** End Dialog Sollgre **

FF_ActivateControl "Sollgre","SG_Name"

do
	Abbruch = false
	
	Select Case FF_ShowDialog ("Sollgre")
	Case "Abbrechen","CANCEL"
		exit do
	Case "Speichern"
		SG_Name   = trim (FF_GetControl("Sollgre","SG_Name"))
		SG_Breite = trim (FF_GetControl("Sollgre","SG_Breite"))
		SG_Hoehe  = trim (FF_GetControl("Sollgre","SG_Hoehe"))
		
		call Def_Kontrolle
		if not Abbruch then
			SGA_Liste = SGA_Liste & "|" & SG_Name
			FF_WriteProfile RegSchluessel,"SGA_Liste",SGA_Liste
			FF_SetControl "PortraitToLandscape","SG_Auswahl",SG_Name
			
			SG_Wert = SG_Breite & " x " & SG_Hoehe
			SGW_Liste = SGW_Liste & "|" & SG_Wert
			FF_WriteProfile RegSchluessel,"SGW_Liste",SGW_Liste
			
			exit do
		end if

	End Select
loop

FF_CloseDialog ("Sollgre")

End Sub
'------------------------------------------------------------------------
Sub Def_Kontrolle

if len(SG_Name) = 0 then
	msgbox "Es muss eine Bezeichnung eingegeben werden.",vbExclamation,"Information"
	Abbruch = true : exit sub
end if

if instr(SG_Name,"|") > 0 then
	msgbox "Die Bezeichnung darf nicht das Zeichen | enthalten.",vbExclamation,"Information"
	Abbruch = true : exit sub
end if

for each element in SGA_Array
	if ucase(element) = ucase(SG_Name) then
		msgbox "Die eingegebene Bezeichnung existiert bereits.",vbExclamation,"Information"
		Abbruch = true : exit sub
	end if
next

if len(SG_Breite) = 0 then
	msgbox "Es muss eine Sollbreite eingegeben werden.",vbExclamation,"Information"
	Abbruch = true : exit sub
else
	SG_Breite = SG_Breite *1
end if

if SG_Breite <= 100 then
	msgbox "Die Sollbreite muss grer als 100 px sein.",vbExclamation,"Information"
	Abbruch = true : exit sub
end if

if len(SG_Hoehe) = 0 then
	msgbox "Es muss eine Sollhhe eingegeben werden.",vbExclamation,"Information"
	Abbruch = true : exit sub
else
	SG_Hoehe = SG_Hoehe *1
end if

if SG_Hoehe <= 100 then
	msgbox "Die Sollhhe muss grer als 100 px sein.",vbExclamation,"Information"
	Abbruch = true : exit sub
end if

if not(SG_Breite > SG_Hoehe) then
	msgbox "Die Sollbreite muss grer sein als die Sollhhe.",vbExclamation,"Information"
	Abbruch = true : exit sub
end if

End Sub
'------------------------------------------------------------------------
Sub Def_Loeschen

SGL_flag = false
if SG_Auswahl = SGL_Auswahl then
	msgbox "Zum Lschen der Sollgre '" & SGL_Auswahl & "' muss" & vbNewLine &_
			"eine andere Sollgre gewhlt werden!" & vbNewLine &_
			"Das Lschflag wird zurck gesetzt.",vbInformation,"Hinweis"
	exit sub
end if

SGA_Liste = SGA_Array(0) : SGW_Liste = SGW_Array(0)
for n = 1 to ubound(SGA_Array)
	if SGA_Array(n) <> SGL_Auswahl then
		SGA_Liste = SGA_Liste & "|" & SGA_Array(n)
		SGW_Liste = SGW_Liste & "|" & SGW_Array(n)
	end if
next

FF_WriteProfile RegSchluessel,"SGA_Liste",SGA_Liste
FF_WriteProfile RegSchluessel,"SGW_Liste",SGW_Liste

FF_SetControl "PortraitToLandscape","SG_Auswahl",""
SGA_Array = split(SGA_Liste,"|")
SGW_Array = split(SGW_Liste,"|")
for n = 0 to ubound(SGA_Array)
	FF_SetControl "PortraitToLandscape","SG_Auswahl",SGA_Array(n)
	if SGA_Array(n) = SG_Auswahl then SG_Wert = SGW_Array(n)
next
FF_SetControl "PortraitToLandscape","SG_Auswahl",SG_Auswahl
SGWe_Array = split(SG_Wert," x ")
SBreite = SGWe_Array(0) *1 : SHoehe = SGWe_Array(1) *1

WshShell.Popup "Die Sollgre '" & SGL_Auswahl & "'" & vbNewLine & "wurde erfolgreich gelscht.",1,"Meldung",vbInformation

End Sub
'------------------------------------------------------------------------
Sub Werte_auslesen

'Sollgre
SG_Auswahl = FF_GetControl("PortraitToLandscape","SG_Auswahl")

'Bild vorhanden > speichern
if FF_GetImageWidth = 0 then
	msgbox "Bitte hochformatiges Bild" & vbNewLine & "auf die Arbeitsflche laden!",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

'Werte
Lage_Wert = FF_GetControl("PortraitToLandscape","Lage_Wert")
US_Wert = FF_GetControl("PortraitToLandscape","US_Wert")
flag_USturbo = FF_GetControl("PortraitToLandscape","flag_USturbo")
HK_Wert = FF_GetControl("PortraitToLandscape","HK_Wert")

Hz_Lage = FF_GetControl("PortraitToLandscape","Hz_Lage")
Rd_Wert = FF_GetControl("PortraitToLandscape","Rd_Wert")
Rd_Farbe = FF_GetControl("PortraitToLandscape","Rd_Farbe")
RD_FarbArray = split(Rd_Farbe," ")


End Sub
'------------------------------------------------------------------------
Sub Kontrolle

IBreite = FF_GetImageWidth *1
IHoehe = FF_GetImageHeight *1

if IBreite = 0 then
	msgbox "Bitte ein Bild" & vbNewLine & "auf die Arbeitsflche laden!",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

if IBreite / IHoehe > SBreite / SHoehe then
	msgbox "Das Verhltnis von Istbreite zu Isthhe (" & round(IBreite / IHoehe,2) & ") ist" & vbNewLine &_
			"grer als das Verhltnis von Sollbreite zu Sollhhe (" & round(SBreite / SHoehe,2) & ")." & vbNewLine & vbNewLine &_
			"Das Skript wird abgebrochen. Es muss ein anderes Bild mit" & vbNewLine &_
			"kleinerem Seitenverhltnis geladen werden.",vbInformation,"Abbruch"
	Abbruch = true : exit sub
end if

if Hz_Lage = "2 Bilder" and FF_GetImageCount = 0 then
	msgbox "Es sollen 2 Bilder abgebildet werden," & vbNewLine &_
			"es fehlt aber die Markierung eines Bildes" & vbNewLine &_
			"im Computerverzeichnis." & vbNewLine &_
			"Daher wird nur ein Bild mittig abgebildet.",vbInformation,"Hinweis"
	HZ_Lage = "Mitte"
end if

if Hz_Lage = "2 Bilder" then
	B_Name2 = FF_GetImageName(0)
	IBreite2 = FF_GetImageFileWidth(B_Name2) *1
	IHoehe2 = FF_GetImageFileHeight(B_Name2) *1
	if IBreite2 / IHoehe2 > SBreite / SHoehe then
		msgbox "Das Verhltnis von Istbreite zu Isthhe (" & round(IBreite2 / IHoehe2,2) & ") ist" & vbNewLine &_
				"grer als das Verhltnis von Sollbreite zu Sollhhe (" & round(SBreite / SHoehe,2) & ")." & vbNewLine & vbNewLine &_
				"Das Skript wird abgebrochen. Im Coputerverzeichnis muss ein anderes Bild mit" & vbNewLine &_
				"kleinerem Seitenverhltnis markiert werden.",vbInformation,"Abbruch"
		Abbruch = true : exit sub
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

'Sollgre
SG_Auswahl =  FF_GetProfile (RegSchluessel,"SG_Auswahl")
if SG_Auswahl = "" then SG_Auswahl = "HDTV - 1080"

SGA_Liste =  FF_GetProfile (RegSchluessel,"SGA_Liste")
if SGA_Liste = "" then SGA_Liste = "HDTV - 1080"

SGW_Liste = FF_GetProfile (RegSchluessel,"SGW_Liste")
if SGW_Liste = "" then SGW_Liste = "1920 x 1080"

'Hintergrundwerte
US_Wert = FF_GetProfile (RegSchluessel,"US_Wert")
if US_Wert = "" then US_Wert = 40

flag_USturbo = FF_GetProfile (RegSchluessel,"flag_USturbo")
if flag_USturbo = "" then flag_USturbo = 1

HK_Wert = FF_GetProfile (RegSchluessel,"HK_Wert")
if HK_Wert = "" then HK_Wert = 150

'Bildwerte 
Hz_Lage = FF_GetProfile (RegSchluessel,"Hz_Lage")
if Hz_Lage = "" then Hz_Lage = "Mitte"
if Hz_Lage = "2 Bilder" and FF_GetImageCount = 0 then Hz_Lage = "Mitte"

Rd_Wert = FF_GetProfile (RegSchluessel,"Rd_Wert")
if Rd_Wert = "" then Rd_Wert = 0

Rd_Farbe = FF_GetProfile (RegSchluessel,"Rd_Farbe")
if Rd_Farbe = "" then Rd_Farbe = "000 000 000"

'### Werte eintragen

'Sollgre
SGA_Array = split(SGA_Liste,"|")
SGW_Array = split(SGW_Liste,"|")
for n = 0 to ubound(SGA_Array)
	FF_SetControl "PortraitToLandscape","SG_Auswahl",SGA_Array(n)
	if SGA_Array(n) = SG_Auswahl then SG_Wert = SGW_Array(n)
next
FF_SetControl "PortraitToLandscape","SG_Auswahl",SG_Auswahl
SGWe_Array = split(SG_Wert," x ")
SBreite = SGWe_Array(0) *1 : SHoehe = SGWe_Array(1) *1

'Hintergrundwerte
FF_SetControl "PortraitToLandscape","US_Wert",US_Wert
FF_SetControl "PortraitToLandscape","flag_USturbo",flag_USturbo
FF_SetControl "PortraitToLandscape","HK_Wert",HK_Wert

'Bildwerte
FF_SetControl "PortraitToLandscape","Hz_Lage",Hz_Lage
FF_SetControl "PortraitToLandscape","Rd_Wert",Rd_Wert
FF_SetControl "PortraitToLandscape","Rd_Farbe",Rd_Farbe

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call Werte_Auslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"SG_Auswahl",SG_Auswahl
FF_WriteProfile RegSchluessel,"US_Wert",US_Wert
FF_WriteProfile RegSchluessel,"flag_USturbo",flag_USturbo
FF_WriteProfile RegSchluessel,"HK_Wert",HK_Wert
FF_WriteProfile RegSchluessel,"Hz_Lage",Hz_Lage
FF_WriteProfile RegSchluessel,"Rd_Wert",Rd_Wert
FF_WriteProfile RegSchluessel,"Rd_Farbe",Rd_Farbe

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Internetverbindung ?
'************************************************************************
'------------------------------------------------------------------------
Function InternetConnection
 
Dim obj
Set obj = GetObject("winmgmts:Win32_PingStatus.address='" & "google.de" & "'")

if IsNull(obj.StatusCode) or obj.StatusCode <> 0 Then
   msgbox "Keine Internetverbindung!",vbInformation,"Hinweis"
   InternetConnection = false
else
   InternetConnection = true
end if
 
End Function
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
'------------------------------------------------------------------------
Sub Update

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Lschroutine
'************************************************************************
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien lschen
'TempFile = """" & FF_GetScriptPath & "\SetDate\SetDate.pdf" & """"			'Dateien
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Ordner lschen
TempFile = FF_GetScriptPath & "\MeckiScript\PortraitToLandscape"			'Ordner
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Standard-Funktionen
'************************************************************************
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
